
import 'dart:async';

import 'package:flutter/services.dart';


export 'package:system_settings/system_settings.dart';
export 'package:cached_network_image/cached_network_image.dart';
export 'package:local_auth/local_auth.dart';
export 'package:dio/dio.dart';
export 'package:package_info/package_info.dart';
export 'package:url_launcher/url_launcher.dart';
export 'package:image_gallery_saver/image_gallery_saver.dart';
export 'package:permission_handler/permission_handler.dart';
export 'package:flustars/flustars.dart';
export 'package:keyboard_actions/keyboard_actions.dart';

export 'config/ky_project_configure.dart';
export 'config/ky_default_utils.dart';
export 'config/ky_chinese_localization.dart';

export 'sizefit/ky_size_fit.dart';
export 'sizefit/ky_int_extension.dart';
export 'sizefit/ky_double_extension.dart';

export 'tools/ky_log_utils.dart';
export 'tools/ky_toast.dart';

export 'ky_reuse_widget/ky_normal_dialog.dart';
export 'ky_reuse_widget/ky_common_sift_page.dart';
export 'ky_reuse_widget/ky_photoview_wipper.dart';


class KyToolPlugin {
  static const MethodChannel _channel =
      const MethodChannel('ky_tool_plugin');


  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }
}
